function JAtom(xml) {
    this._parse(xml);
};

JAtom.prototype = {
    
    _parse: function(xml) {
    
        var channel = AJS.$('feed', xml).eq(0);
        var thisFeed = this;
        this.version = '1.0';
        this.title = AJS.$(channel).find('title:first').text();
        this.link = AJS.$(channel).find('link:first').attr('href');
        this.description = AJS.$(channel).find('subtitle:first').text();
        this.language = AJS.$(channel).attr('xml:lang');
        this.updated = AJS.$(channel).find('updated:first').text();
        
        this.items = new Array();
        
        var feed = this;
        
        AJS.$('entry', xml).each( function() {
        
            var item = new JFeedItem();
            
            item.title = AJS.$(this).find('title').eq(0).text();
            AJS.$(this).find('link').each(function()
            {
                var rel = AJS.$(this).attr("rel");
                var href = AJS.$(this).attr("href");
                if (rel == "alternate")
                {
                    item.link = href;
                }
                else if (rel == "http://streams.atlassian.com/syndication/reply-to")
                {
                    item.replyTo = href;
                }
                else if (rel == "http://streams.atlassian.com/syndication/icon")
                {
                    item.icon = href;
                }
            });
            item.summary = AJS.$(this).find('summary').eq(0).text();
            item.updated = AJS.$(this).find('updated').eq(0).text();
            item.id = AJS.$(this).find('id').eq(0).text();
            item.category = AJS.$(this).find('category:first').attr("term");
            AJS.$(this).find("author").each( function() {
                item.authors.push(thisFeed._parsePerson(this));
            });
            feed.items.push(item);
        });
    },
    _parsePerson: function(xml)
    {
        var person = new JFeedPerson();
        person.name = AJS.$(xml).find('name').eq(0).text();
        person.email = AJS.$(xml).find('email').eq(0).text();
        person.uri = AJS.$(xml).find('uri').eq(0).text();
        person.username = AJS.$(xml).find('username').eq(0).text();
        return person;
    },
    _getContentValue: function(content, name)
    {
        var element = content.find(name + ":first");
        if (element)
        {
            return element.text();
        }
        else
        {
            return "";
        }
    }
};

function JFeedItem() {
    this.authors = new Array();
};
JFeedItem.prototype = {
    title: '',
    link: '',
    summary: '',
    updated: '',
    id: '',
    category: '',
    inReplyTo: '',
    replyTo: '',
    icon: ''
};

function JFeedPerson() {};
JFeedPerson.prototype = {
    name: '',
    email: '',
    uri: '',
    username: ''
};