jQuery(function($) {
    
    var dashboardUrl = $("#dashboard-url").attr("href");
    
    $(".add-it-now").click(function(event) {
        var addItNowButton = $(this);
        addItNowButton.attr("disabled", "disabled").attr("value", "Adding...");
        var gadgetUrl = addItNowButton.next().attr("value");
        addGadget(gadgetUrl, callbacks(addItNowButton, addItNowSuccess, addItNowError));
        return false;
    });

    function addGadget(gadgetUrl, callbacks) {
        var params = {
            type: "POST",
            url: dashboardUrl,
            data: { url: gadgetUrl }
        };
        $.extend(params, callbacks);
        $.ajax(params);
    }
    
    function callbacks(extraData, success, error) {
        return {
            success: function(data, textStatus) {
                success(extraData, data, textStatus);
            },
            error: function(request, textStatus, errorThrown) {
                error(extraData, request, textStatus, errorThrown);
            }
        };
    }
    
    function addItNowSuccess(button, data, textStatus) {
        window.location = $("ul.menu li a").attr("href");
        var button = $(button);
        button.parents(".entry").css("background", "#fffe83")
                                .animate({ backgroundColor: "transparent" }, 2000, "linear", function(){addingEntry(button);}); 
    }
    
    function addItNowError(gadgetContainer, request, textStatus, errorThrown) {
        console.log("addItNowError");
        $(button).parents(".entry").css("background", "#faa");
        button.blur(); 
    }
    
    function addingEntry(button) {
        var button = $(button);
        button.removeAttr("disabled").attr("value", "Add it now");
        button.parents(".entry").removeAttr("style");
        button.blur();        
    }
    
    $("#directory .entry").hover(function() {
        $(this).addClass("hover");
    }, function () {
        $(this).removeClass("hover");
    });
    
});
